import { clone } from './clone'
import assert from 'assert'

test('with array', () => {
  const arr = [
    {
      b : 2,
      c : 'foo',
      d : [ 1, 2, 3 ],
    },
    1,
    new Date(),
    null,
  ]
  expect(clone(arr)).toEqual(arr)
})

test('with object', () => {
  const arr = {
    a : 1,
    b : 2,
    c : 3,
    d : [ 1, 2, 3 ],
    e : new Date(),
  }
  expect(clone(arr)).toEqual(arr)
})
 
test('with date', () => {
  const date = new Date(2014, 10, 14, 23, 59, 59, 999)

  const cloned = clone(date)
  assert.notStrictEqual(date, cloned)
  expect(cloned).toEqual(new Date(2014, 10, 14, 23, 59, 59, 999))

  expect(cloned.getDay()).toEqual(5)
})
