import { add } from './add'
import { map } from './map'
import { multiply } from './multiply'
import { filter } from './filter'
import { last } from './last'
import { compose } from './compose'

test('happy', () => {
  const result = compose(
    last,
    map(add(10)),
    map(add(1))
  )([ 1, 2, 3 ])

  expect(result).toEqual(14)
})

test('accepts initially two arguments', () => {
  const result = compose(
    map(x => x * 2),
    (a, y) => filter(x => x > y, a)
  )([ 1, 2, 3, 4 ], 2)

  expect(result).toEqual([ 6, 8 ])
})

test('when no arguments is passed', () => {
expect(() => compose()).toThrow('compose requires at least one argument');
})

test('ramda spec', () => {
  var f = function(a, b, c) { return [a, b, c]; };
var g = compose(f);
expect(g(1, 2, 3)).toEqual([1, 2,3])
})
