import { dropLast } from './dropLast'
import assert from 'assert'

test('with array', () => {
  expect(dropLast(2)([ 'foo', 'bar', 'baz' ])).toEqual([ 'foo' ])
  expect(dropLast(3, [ 'foo', 'bar', 'baz' ])).toEqual([])
  expect(dropLast(4, [ 'foo', 'bar', 'baz' ])).toEqual([])
})
test('with string', () => {
  expect(dropLast(3, 'rambda')).toEqual('ram')
})

test('with non-positive count', () => {
  expect(dropLast(0, [1, 2, 3])).toEqual([1, 2, 3])
expect(dropLast(-1, [1, 2, 3])).toEqual([1, 2, 3]) 
expect(dropLast(-Infinity, [1, 2, 3])).toEqual([1, 2, 3])
})

test('should return copy', () => {
    var xs = [1, 2, 3];

    assert.notStrictEqual(dropLast(0, xs), xs);
    assert.notStrictEqual(dropLast(-1, xs), xs);
})
